﻿using System;
using System.Reflection;

namespace Common.Commands
{
    public enum RequestCommand
    {
        [CommandValue("000")]
        Poll = 000,
        [CommandValue("001")]
        StatusReport = 001,
        [CommandValue("008")]
        DumpZoneTimers = 008,
        [CommandValue("005")]
        NetworkLogin = 005,
        [CommandValue("010")]
        SetTimeAndDate = 010,
        [CommandValue("020")]
        CommandOutputControl = 020,
        [CommandValue("030")]
        PartitionArmControl = 030,
        [CommandValue("031")]
        PartitionArmControlStayArm = 031,
        [CommandValue("032")]
        PartitionArmControlZeroEntryDelay = 032,
        [CommandValue("033")]
        PartitionArmControlWithCode = 033,
        [CommandValue("040")]
        PartitionDisarmControl = 040,
        [CommandValue("055")]
        TimeStampControl = 055,
        [CommandValue("056")]
        TimeBroadcastControl = 056,
        [CommandValue("057")]
        TemperatureBroadcastControl = 057,
        [CommandValue("060")]
        TriggerPanicAlarm = 060,
        [CommandValue("070")]
        SingleKeystrokePartition1 = 070,
        [CommandValue("071")]
        SendKeystrokeString = 071,
        [CommandValue("072")]
        EnterUserCodeProgramming = 072,
        [CommandValue("073")]
        EnterUserProgramming = 073,
        [CommandValue("074")]
        KeepAlive = 074,
        [CommandValue("200")]
        CodeSend = 200
    }

    public static class RequestClass
    {
        public static int GetNumberOfBytes(Enum value)
        {
            // Get the type
            Type type = value.GetType();

            // Get fieldinfo for this type
            FieldInfo fieldInfo = type.GetField(value.ToString());

            // Get the stringvalue attributes
            var attribs = fieldInfo.GetCustomAttributes(
                typeof(CommandValueAttribute), false) as CommandValueAttribute[];

            // Return the first if there was a match.
            return attribs.Length > 0 ? attribs[0].NumBytes : 0;
        }

    }
}