﻿using System;
using System.Diagnostics;
using System.Net.Sockets;
using System.Text;
using System.Text.RegularExpressions;
using Common;

namespace Logic.Communications
{
    public class Reciever: IReciever
    {
        public bool Shutdown { get; set; }
        private TcpClient _tcpClient;
        public event EventHandler<EventArgs> EventOccured;

        public Reciever(TcpClient tcpClient)
        {
            Shutdown = false;
            _tcpClient = tcpClient;
        }
        public void ReplaceClient(TcpClient tcpClient)
        {
            Shutdown = false;
            _tcpClient = tcpClient;
        }

        public void Run()
        {
            var clientStream = _tcpClient.GetStream();
            var message = new byte[4096];

            while (!Shutdown)
            {
                var bytesRead = 0;

                try
                {
                    //blocks until a client sends a message
                    bytesRead = clientStream.Read(message, 0, 4096);
                }
                catch
                {
                    //a socket error has occured
                    break;
                }

                if (bytesRead == 0)
                {
                    //the client has disconnected from the server
                    break;
                }

                //message has successfully been received
                var encoder = new ASCIIEncoding();


                var value = encoder.GetString(message, 0, bytesRead);
                var lines = Regex.Split(value, "\r\n");
                foreach (var line in lines)
                {
                    if (!String.IsNullOrEmpty(line))
                    {
                        var r = new TpiResponse(line);
                        if (EventOccured != null) EventOccured(this, r);
                    }
                }
            }

            _tcpClient.Close();
        }

        public void Subscribe(IResponseHandler responseEventHandler)
        {
            //_eventLog.WriteEntry("Adding: " + responseEventHandler.GetName());
            EventOccured += responseEventHandler.HandleEvent;
        }

        public void UnSubscribe(IResponseHandler responseEventHandler)
        {
            //_eventLog.WriteEntry("Removing: " + responseEventHandler.GetName());
            EventOccured -= responseEventHandler.HandleEvent;
        }
    }
}
