﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using Common;
using Common.Commands;
using Logic.Communications;

namespace Logic.Helper
{
    public class ResponseGetter : AbstractResponseEventHandler
    {
        private readonly AutoResetEvent _autoResetEvent = new AutoResetEvent(false);

        private readonly IList<ResponseCommand> _commands;
        private readonly string _data;
        private IResponse _returnData;

        public ResponseGetter(IList<ResponseCommand> commands, string data)
        {
            _commands = commands;
            _data = data;
        }

        public override void EventOccured(IResponse response, IReciever r)
        {
            if (_commands.Contains(response.Command))
            {
                if (_data == null || response.Data.StartsWith(_data))
                {
                    //data recived.
                    _returnData = response;
                    _autoResetEvent.Set();
                    r.UnSubscribe(this); //remove myself response found.
                }
            }
        }

        public IResponse GetResponse()
        {
            //wait for data.
            _autoResetEvent.WaitOne();
            //return data;
            return _returnData;
        }
    }
}
