﻿using System;
using System.Collections.Generic;
using System.Text;
using Common.Commands;
using Logic.Communications;
using MainProgram.Tpi;
using Plugins;

namespace MainProgram
{
    class Program
    {
        static void Main(string[] args)
        {
            var communicationInitor = new CommunicationInitator("server", "password");

            // Do stuff

            // subscribe the zonehandler class to handle Zone events.
            Communicator.GetInstance().Subscribe(new ZoneHandler());
            // subscribe the powerhandler class to handle Power events.
            Communicator.GetInstance().Subscribe(new PowerHandler());

            // simulate someone pressing 1234 on the keypad.
            var request = new TpiRequest(RequestCommand.SendKeystrokeString, "1234");
            Communicator.GetInstance().ExecuteRequest(request);


            //wait for an enter before shutdown
            Console.ReadLine();

            communicationInitor.Shutdown();
        }
    }
}
