﻿using System;
using Common;
using Common.Commands;

namespace Plugins
{
    public class LoginHandler : AbstractResponseEventHandler
    {
        private readonly Action<LoginHandler> _action;
        private readonly Action<LoginHandler> _wrongPasswordAction;


        public LoginHandler(Action<LoginHandler> continueWithLogin, Action<LoginHandler> wrongPasswordAction)
        {
            _action = continueWithLogin;
            _wrongPasswordAction = wrongPasswordAction;
        }

        public override void EventOccured(IResponse response, IReciever r)
        {
            if (ResponseCommand.LoginInteraction == response.Command)
            {
                if (response.Data.Equals("3"))
                {
                    _action.Invoke(this);
                }
                else if (response.Data.Equals("0"))
                {
                    _wrongPasswordAction.Invoke(this);
                }
            }
        }
    }
}

